org.apache.xalan.templates

## Class AVTPartXPath

- java.lang.Object
- - org.apache.xalan.templates.AVTPart
  - - org.apache.xalan.templates.AVTPartXPath

- All Implemented Interfaces:
    java.io.Serializable, XSLTVisitable

      public class AVTPartXPath
      extends AVTPart

  Simple string part of a complex AVT.
  See Also:
    Serialized Form
  Usage:
    **For internal use only**

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AVTPartXPath(java.lang.String val, PrefixResolver nsNode, XPathParser xpathProcessor, XPathFactory factory, XPathContext liaison)` Construct a simple AVT part.
    `AVTPartXPath(XPath xpath)` Construct a simple AVT part.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `callVisitors(XSLTVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
    `boolean` | `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
    `void` | `evaluate(XPathContext xctxt, FastStringBuffer buf, int context, PrefixResolver nsNode)` Write the value into the buffer.
    `void` | `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
    `java.lang.String` | `getSimpleString()` Get the AVT part as the original string.

    - ### Methods inherited from class org.apache.xalan.templates.AVTPart

      `setXPathSupport`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AVTPartXPath

          public AVTPartXPath(XPath xpath)

      Construct a simple AVT part.
      Parameters:
        `xpath` - Xpath section of AVT

    - #### AVTPartXPath

          public AVTPartXPath(java.lang.String val,
                              PrefixResolver nsNode,
                              XPathParser xpathProcessor,
                              XPathFactory factory,
                              XPathContext liaison)
                       throws javax.xml.transform.TransformerException

      Construct a simple AVT part.
      Parameters:
        `val` - A pure string section of an AVT.
        `nsNode` - An object which can be used to determine the Namespace Name (URI) for any Namespace prefix used in the XPath. Usually this is based on the context where the XPath was specified, such as a node within a Stylesheet.
        `xpathProcessor` - XPath parser
        `factory` - XPath factory
        `liaison` - An XPathContext object, providing infomation specific to this invocation and this thread. Maintains SAX output state, variables, error handler and so on, so the transformation/XPath object itself can be simultaneously invoked from multiple threads.
      Throws:
        `javax.xml.transform.TransformerException` - TODO: Fix or remove this unused c'tor.

  - ### Method Detail

    - #### fixupVariables

          public void fixupVariables(java.util.Vector vars,
                                     int globalsSize)

      This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
      Specified by:
        `fixupVariables` in class `AVTPart`
      Parameters:
        `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

    - #### canTraverseOutsideSubtree

          public boolean canTraverseOutsideSubtree()

      Tell if this expression or it's subexpressions can traverse outside the current subtree.
      Overrides:
        `canTraverseOutsideSubtree` in class `AVTPart`
      Returns:
        true if traversal outside the context node's subtree can occur.

    - #### getSimpleString

          public java.lang.String getSimpleString()

      Get the AVT part as the original string.
      Specified by:
        `getSimpleString` in class `AVTPart`
      Returns:
        the AVT part as the original string.

    - #### evaluate

          public void evaluate(XPathContext xctxt,
                               FastStringBuffer buf,
                               int context,
                               PrefixResolver nsNode)
                        throws javax.xml.transform.TransformerException

      Write the value into the buffer.
      Specified by:
        `evaluate` in class `AVTPart`
      Parameters:
        `xctxt` - An XPathContext object, providing infomation specific to this invocation and this thread. Maintains SAX state, variables, error handler and so on, so the transformation/XPath object itself can be simultaneously invoked from multiple threads.
        `buf` - Buffer to write into.
        `context` - The current source tree context.
        `nsNode` - The current namespace context (stylesheet tree context).
      Throws:
        `javax.xml.transform.TransformerException`

    - #### callVisitors

          public void callVisitors(XSLTVisitor visitor)

      Description copied from interface: `XSLTVisitable`
      This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.
      Parameters:
        `visitor` - The visitor whose appropriate method will be called.
      See Also:
        `XSLTVisitable.callVisitors(XSLTVisitor)`

Copyright © 2023 Apache XML Project. All Rights Reserved.